
; CC5X Version 3.5D, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  21. Feb 2016  12:52  *************

        processor  16F88
        radix  DEC

        __config 0x2007, 0x2F06

TMR0        EQU   0x01
PCL         EQU   0x02
STATUS      EQU   0x03
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
INTCON      EQU   0x0B
INTEDG      EQU   6
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
INTF        EQU   1
T0IF        EQU   2
INTE        EQU   4
GIE         EQU   7
OPTION_REG  EQU   0x81
TMR1L       EQU   0x0E
TMR1H       EQU   0x0F
T1CON       EQU   0x10
TMR2        EQU   0x11
T2CON       EQU   0x12
CCP1CON     EQU   0x17
PR2         EQU   0x92
ANSEL       EQU   0x9B
WDTCON      EQU   0x105
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EECON2      EQU   0x18D
PEIE        EQU   6
TMR2IF      EQU   1
CCP1IF      EQU   2
EEIF        EQU   4
TMR1ON      EQU   0
TMR2ON      EQU   2
TMR2IE      EQU   1
CCP1IE      EQU   2
RD          EQU   0
WR          EQU   1
WREN        EQU   2
EEPGD       EQU   7
dim_grade   EQU   0x27
dim_1       EQU   0x28
dim_2       EQU   0x29
cycles      EQU   0x2A
Puls        EQU   0x2B
PulseOn     EQU   0
Stable      EQU   1
actPattern  EQU   0x2D
PatternPos  EQU   0x2E
PatternMask EQU   0x2F
seconds     EQU   0x30
minutes     EQU   0x31
hours       EQU   0x32
ircode      EQU   0x33
save_counter EQU   0x35
irled       EQU   0x37
old_dim_grade EQU   0x38
tmr0cpy     EQU   0x39
irledn      EQU   0
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
svrPCLATH   EQU   0x21
adr         EQU   0x23
data        EQU   0x24
prev_gie    EQU   0
adr_2       EQU   0x24
t           EQU   0x25
t_2         EQU   0x25
i           EQU   0x26
ton         EQU   0x23
toff        EQU   0x24
h           EQU   0x23
waiter      EQU   0x23
counter     EQU   0x24
tmp         EQU   0x22
C1cnt       EQU   0x23
C2tmp       EQU   0x24
ci          EQU   0x24

        GOTO main

  ; FILE d:\projekte\picsel\dimmer2\dimmer2.c
                        ;/* DIMMER2 for 230VAC                             */
                        ;/*                                                */
                        ;/*                __    _                         */                     
                        ;/*     __________/ /_  (_)________   ___  __  __  */ 
                        ;/*    / ___/ ___/ __ \/ / ___/ __ \ / _ \/ / / /  */
                        ;/*   (__  ) /__/ / / / / /  / /_/ //  __/ /_/ /   */
                        ;/*  /____/\___/_/ /_/_/_/  / .___(_)___/\__,_/    */
                        ;/*                        /_/                     */
                        ;/*                                                */
                        ;/* (c) C.Schirp  released for non-commercial use  */
                        ;/* IR-routines copyright by Jos van Eijndhoven    */
                        ;/*                                                */
                        ;/* V1.0  Erstausgabe                              */
                        ;/* V1.1  Schnellere Zndentscheidung ohne Jitter  */
                        ;/*       Standby-Taste, Optimierungen             */
                        ;/* V1.11 Portchange fuer Eagle-PCB                */ 
                        ;/*                                                */
                        ;
                        ;
                        ;#include <d:\projekte\picsel\cc5\16F88.h>
                        ;#include <d:\projekte\picsel\cc5\int16CXX.h>
                        ;#include <d:\projekte\picsel\cc5\inline.h>
                        ;
                        ;//#include <C:\Eigene_Dateien\pic\cc5x\16F88.h>
                        ;//#include <C:\Eigene_Dateien\pic\cc5x\int16CXX.h>
                        ;//#include <C:\Eigene_Dateien\pic\cc5x\inline.h>
                        ;
                        ;#pragma config = 0b.0010.1111.0000.0110 
                        ;
                        ;// 13 CP: Flash Program Memory Code Protection bits 1 = Code protection off
                        ;// 12 CCPMX: CCP1 Pin Selection bit 1 = CCP1 function on RB0 0 = CCP1 function on RB3
                        ;// 11 DEBUG: In-Circuit Debugger Mode bit 1 = In-Circuit Debugger disabled, RB6 and RB7 are GPIO
                        ;// 10-9 WRT<1:0>: Flash Program Memory Write Enable bits 11 = Write protection off
                        ;//  8 CPD: Data EE Memory Code Protection bit 1 = Code protection off
                        ;//  7 LVP: Low-Voltage Programming Enable bit 0 = RB3 is digital I/O, HV on MCLR must be used for programming
                        ;//  6 BOREN: Brown-out Reset Enable  1 = BOR enabled 0 = BOR disabled
                        ;//  5 MCLRE: RA5/MCLR/VPP Pin Function Select bit 0 = RA5/MCLR/VPP pin function is digital I/O, MCLR internally tied to VDD
                        ;//  3 PWRTEN: Power-up Timer Enable bit 1 = PWRT disabled 0 = PWRT enabled
                        ;//  2 WDTEN: Watchdog Timer Enable bit 1 = WDT enabled 0 = WDT disabled
                        ;//  4, 1-0 FOSC<2:0>: Oscillator Selection bits 
                        ;//             100 = INTRC oscillator; port I/O function on both RA6/OSC2/CLKO pin and RA7/OSC1/CLKI pin
                        ;//             010 = HS oscillator
                        ;
                        ;#pragma config_reg2 = 0b.1111.1111.1111.1100 
                        ;// 13-2 Unimplemented: Read as 1
                        ;// 1 IESO: Internal External Switchover bit 1 = Internal External Switchover mode enabled, 0 =  disabled
                        ;// 0 FCMEN: Fail-Safe Clock Monitor Enable bit 1 = Fail-Safe Clock Monitor enabled, 0 = disabled
                        ;
                        ;
                        ;
                        ;/* Defines */
                        ;
                        ;#define LED_OFF PORTA.1
                        ;#define BUZZER PORTA.0
                        ;#define ZERO_CROSS PORTB.3
                        ;#define GATE PORTB.1
                        ;
                        ;#define MIN_DIM 0	/* minimaler Dimgrad */
                        ;#define MAX_DIM 8	/* maximaler Dimgrad */
                        ;
                        ;#define GATE_AKTIV 1
                        ;#define GATE_PASSIV 0
                        ;
                        ;#define SAVETIME	625	/* nach SAVETIME mal 8ms wird der dimwert ins eeprom geschrieben */
                        ;
                        ;unsigned char dim_grade;	 //debounced and inverted dimming grade 10...100:
                        ;unsigned char dim_1;
                        ;unsigned char dim_2;
                        ;
                        ;unsigned char cycles;
                        ;unsigned char Puls;		// Statemachine fuer Gatezuendung
                        ;unsigned char PulseOn:1;	// Auf eins wenn der nchste Puls gezndet werden soll
                        ;unsigned char Stable:1;		// Ist Zerocross-Erkennung stabil
                        ;unsigned char actPattern;
                        ;unsigned char PatternPos;
                        ;unsigned char PatternMask;		// wandernde Bitmaske fr das Firepattern
                        ;
                        ;unsigned char seconds;		// Uhr-Variablen
                        ;unsigned char minutes;
                        ;unsigned char hours;
                        ;
                        ;
                        ;uns16  ircode;
                        ;uns16  save_counter;
                        ;unsigned char irled; // 1 if light is on
                        ;unsigned char old_dim_grade;
                        ;
                        ;
                        ;unsigned char tmr0cpy;
                        ;
                        ;
                        ;
                        ;//bit Monitor; // Shadow fuer PB6
                        ;
                        ;bit irledn     @ PORTB.0;
                        ;
                        ;const unsigned char FirePattern[9] = {
                        ;0, 
                        ;0b1000.0000,
                        ;0b1000.1000,
                        ;0b1001.0010,
                        ;0b1010.1010,
                        ;0b1010.1110,
                        ;0b1110.1110,
                        ;0b1111.1110,
                        ;0b1111.1111,
                        ;};
                        ;
                        ;
                        ;/*------------------------------------------------------------------*/
                        ;/*                                                                  */
                        ;/*                                                                  */
                        ;/*                                                                  */
                        ;/*                                                                  */
                        ;/*                                                                  */
                        ;/*------------------------------------------------------------------*/
                        ;
                        ;
                        ;#pragma origin 4
        ORG 0x0004
                        ;interrupt int_server( void)
                        ;{
int_server
                        ;    int_save_registers    // W, STATUS (and PCLATH)
        MOVWF svrWREG
        SWAPF STATUS,W
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF svrSTATUS
        MOVF  PCLATH,W
        MOVWF svrPCLATH
        CLRF  PCLATH
                        ;
                        ;    if (INTF)
        BTFSS 0x0B,INTF
        GOTO  m003
                        ;    {
                        ;        /* RB0/INT interrupt */
                        ;        irled.0 = !irledn;
        BSF   irled,0
        BTFSC 0x06,irledn
        BCF   irled,0
                        ;        INTF = 0;
        BCF   0x0B,INTF
                        ;        if (irled)     // request interrupt on next edge (up or down)
        MOVF  irled,1
        BTFSC 0x03,Zero_
        GOTO  m001
                        ;           INTEDG = 1; // if 1, then interrupt on rising edge
        BSF   0x03,RP0
        BSF   0x81,INTEDG
                        ;        else
        GOTO  m002
                        ;           INTEDG = 0; // is part of OPTION_REG, is 1 on reset
m001    BSF   0x03,RP0
        BCF   0x03,RP1
        BCF   0x81,INTEDG
                        ;
                        ;        /* finish and restart TMR0 */
                        ;        tmr0cpy = TMR0;
m002    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  TMR0,W
        MOVWF tmr0cpy
                        ;        TMR0 = 0;
        CLRF  TMR0
                        ;        T0IF = 1; // end polling wait-loop, similar to TRM0 wraparound
        BSF   0x0B,T0IF
                        ;    }
                        ;    
                        ;    if (CCP1IF) // capture compare Int -> Halbwellenanfang
m003    BCF   0x03,RP0
        BCF   0x03,RP1
        BTFSS 0x0C,CCP1IF
        GOTO  m011
                        ;    {
                        ; 		
                        ;	if (PulseOn && Stable) // wenn der Puls aktiv sein soll, Timing starten
        BTFSS 0x2C,PulseOn
        GOTO  m004
        BTFSS 0x2C,Stable
        GOTO  m004
                        ; 	{
                        ;	 	GATE = GATE_AKTIV;
        BSF   PORTB,1
                        ;		Puls=1;
        MOVLW 1
        MOVWF Puls
                        ;		
                        ;		TMR2ON=0; // Timer 2 stoppen
        BCF   0x12,TMR2ON
                        ;	    	TMR2 = 0; // neu aufziehen
        CLRF  TMR2
                        ;		PR2=   23; // ca. 200us
        MOVLW 23
        BSF   0x03,RP0
        MOVWF PR2
                        ;		
                        ;		TMR2IE = 1; // Timer 2 Int enablen
        BSF   0x8C,TMR2IE
                        ;		TMR2ON = 1; // Timer 2 starten
        BCF   0x03,RP0
        BSF   0x12,TMR2ON
                        ;	}
                        ;	
                        ;	if (ZERO_CROSS) // wenn positive Halbwelle trigger auf fallend
m004    BCF   0x03,RP0
        BCF   0x03,RP1
        BTFSS PORTB,3
        GOTO  m009
                        ;	{
                        ;		CCP1CON = 0b0000.0100; // Capture every falling edge
        MOVLW 4
        MOVWF CCP1CON
                        ;		cycles++;
        INCF  cycles,1
                        ;		
                        ;		// == Gate-Freigabe berechnen
                        ;		PatternPos++;
        INCF  PatternPos,1
                        ;						
                        ;		if (PatternPos > 7)
        MOVLW 8
        SUBWF PatternPos,W
        BTFSS 0x03,Carry
        GOTO  m005
                        ;		{
                        ;			PatternPos = 0;
        CLRF  PatternPos
                        ;			PatternMask =   1;
        MOVLW 1
        MOVWF PatternMask
                        ;		}
                        ;		else
        GOTO  m006
                        ;		{
                        ;			PatternMask<<=1;
m005    BCF   0x03,Carry
        BCF   0x03,RP0
        BCF   0x03,RP1
        RLF   PatternMask,1
                        ;		}
                        ;		
                        ;		if (actPattern & PatternMask)
m006    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  PatternMask,W
        ANDWF actPattern,W
        XORLW 0
        BTFSC 0x03,Zero_
        GOTO  m007
                        ;		{
                        ;			PulseOn = 1;
        BSF   0x2C,PulseOn
                        ;		}
                        ;		else
        GOTO  m008
                        ;		{
                        ;			PulseOn = 0;
m007    BCF   0x03,RP0
        BCF   0x03,RP1
        BCF   0x2C,PulseOn
                        ;		}
                        ;			
                        ;		
                        ;	}
                        ;	else
m008    GOTO  m010
                        ;	{
                        ;		CCP1CON = 0b0000.0101; // Capture every rising edge
m009    MOVLW 5
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF CCP1CON
                        ;	}
                        ;	
                        ;	CCP1IF = 0; // CCP-Int-Flag loeschen
m010    BCF   0x03,RP0
        BCF   0x03,RP1
        BCF   0x0C,CCP1IF
                        ;	
                        ;    }
                        ;    
                        ;
                        ;    if (TMR2IF) // Timer 2 Flag, Gatepuls-Erzeugung
m011    BCF   0x03,RP0
        BCF   0x03,RP1
        BTFSS 0x0C,TMR2IF
        GOTO  m017
                        ;    {
                        ;
                        ;    	switch (Puls)
        MOVF  Puls,W
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m012
        XORLW 3
        BTFSC 0x03,Zero_
        GOTO  m013
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m014
        GOTO  m015
                        ;    	{
                        ;    		
                        ;    		case 1:	GATE = GATE_PASSIV;
m012    BCF   0x03,RP0
        BCF   0x03,RP1
        BCF   PORTB,1
                        ;    			Puls=2;
        MOVLW 2
        MOVWF Puls
                        ;    			PR2= 100;//  800us 
        MOVLW 100
        BSF   0x03,RP0
        MOVWF PR2
                        ;    			break; 
        GOTO  m016
                        ;    		case 2:	GATE = GATE_AKTIV;
m013    BCF   0x03,RP0
        BCF   0x03,RP1
        BSF   PORTB,1
                        ;    			Puls=3;
        MOVLW 3
        MOVWF Puls
                        ;    			PR2= 12;//  100us
        MOVLW 12
        BSF   0x03,RP0
        MOVWF PR2
                        ;    			break; 
        GOTO  m016
                        ;    		case 3:	GATE = GATE_PASSIV;
m014    BCF   0x03,RP0
        BCF   0x03,RP1
        BCF   PORTB,1
                        ;    			Puls=0;
        CLRF  Puls
                        ;    			TMR2ON = 0; // Timer 2 stoppen
        BCF   0x12,TMR2ON
                        ;    			TMR2IE = 0; // Timer 2 int disable
        BSF   0x03,RP0
        BCF   0x8C,TMR2IE
                        ;    			break; 
        GOTO  m016
                        ;    			   			
                        ;    		default: GATE = GATE_PASSIV;
m015    BCF   0x03,RP0
        BCF   0x03,RP1
        BCF   PORTB,1
                        ;    			Puls=0;
        CLRF  Puls
                        ;    			TMR2ON = 0; // Timer 2 stoppen
        BCF   0x12,TMR2ON
                        ;    			TMR2IE = 0; // Timer 2 int disable
        BSF   0x03,RP0
        BCF   0x8C,TMR2IE
                        ;    			break;
        GOTO  m016
                        ;    	}
                        ;	TMR2IF =0; // Int-Flag loeschen
m016    BCF   0x03,RP0
        BCF   0x03,RP1
        BCF   0x0C,TMR2IF
                        ;    }
                        ;
                        ;
                        ;   /*
                        ;     NOTE: GIE is AUTOMATICALLY cleared on interrupt entry and set
                        ;           to 1 on exit (by RETFIE). Setting GIE to 1 inside the
                        ;           interrupt service routine will cause nested interrupts
                        ;           if an interrupt is pending. Too deep nesting may crash
                        ;           the program !
                        ;   */
                        ;
                        ;    int_restore_registers // W, STATUS (and PCLATH)
m017    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  svrPCLATH,W
        MOVWF PCLATH
        SWAPF svrSTATUS,W
        MOVWF STATUS
        SWAPF svrWREG,1
        SWAPF svrWREG,W
                        ;}
        RETFIE
                        ;
                        ;/*------------------------------------------------------------------*/
                        ;/*   II  N   N  II TTTTT                                            */
                        ;/*   II  NN  N  II   T                                              */
                        ;/*   II  N N N  II   T                                              */
                        ;/*   II  N  NN  II   T                                              */
                        ;/*   II  N   N  II   T                                              */
                        ;/*------------------------------------------------------------------*/
                        ;
                        ;
                        ;void init ()
                        ;{
_const1
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF ci
        MOVLW 9
        SUBWF ci,W
        BTFSS 0x03,Carry
        GOTO  m018
        RETLW 0
m018    BCF   0x03,RP0
        BCF   0x03,RP1
        CLRF  PCLATH
        MOVF  ci,W
        ADDWF PCL,1
        RETLW 0
        RETLW 128
        RETLW 136
        RETLW 146
        RETLW 170
        RETLW 174
        RETLW 238
        RETLW 254
        RETLW 255
init
                        ;
                        ;	WDTCON = 0b0001.0011;	// Watchdog-Zyklus 1:16394 = 0,5s
        MOVLW 19
        BCF   0x03,RP0
        BSF   0x03,RP1
        MOVWF WDTCON
                        ;	
                        ;	PORTB = 0b0000.0000;	// Gate auf Inaktiv
        BCF   0x03,RP1
        CLRF  PORTB
                        ;	PORTA = 0b0000.0010;	// LED aus	
        MOVLW 2
        MOVWF PORTA
                        ;	
                        ;	ANSEL = 0;	// Alle Analogports auf Digitalbetrieb	
        BSF   0x03,RP0
        CLRF  ANSEL
                        ;	TRISB = 0b1100.1001; 	// Alles Ausgnge - RB0/Int, ICSPs, ZeroCross Eingang	
        MOVLW 201
        MOVWF TRISB
                        ;	TRISA = 0b1111.0000;	// alles Ausgnge
        MOVLW 240
        MOVWF TRISA
                        ;
                        ;	/* Timer 0: IR-Empfang */
                        ;	/* wird mit OPTION_REG programmiert */
                        ;
                        ;	/* Timer 1: Capture - Messen der Halbwellendauer am Zero-Cross-Eingang RB3/CCP1 */
                        ;	/* Aufloesung: 1us */
                        ;	
                        ;	T1CON = 	0b0001.0000; // Prescaler 1:2, internal Clock, Timer stopped (TMR1ON = 0)
        MOVLW 16
        BCF   0x03,RP0
        MOVWF T1CON
                        ;	CCP1CON = 	0b0000.0100; // Capture every falling edge
        MOVLW 4
        MOVWF CCP1CON
                        ;	
                        ;	/* Timer 2: Gatepuls-Timing */
                        ;	/* 8us Aufloesung */
                        ;	
                        ;	T2CON = 	0b0000.0010; // no postscale, timer off, prescale 1:16 
        MOVLW 2
        MOVWF T2CON
                        ;
                        ;
                        ;	/*sonstiges*/
                        ;	OPTION_REG = 0b.1000.0101; /* no pull-up portB, falling edge int, no WDT prescaler, prescale=64 */
        MOVLW 133
        BSF   0x03,RP0
        MOVWF OPTION_REG
                        ;
                        ;
                        ;	/* Variablen initialisieren */
                        ;
                        ;	save_counter = 	0; 	// nix schreiben
        BCF   0x03,RP0
        CLRF  save_counter
        CLRF  save_counter+1
                        ;	irled = 	0;
        CLRF  irled
                        ;	seconds = 	0;	// Uhr-Variablen
        CLRF  seconds
                        ;	minutes =	0;
        CLRF  minutes
                        ;	hours =		0;
        CLRF  hours
                        ;	
                        ;
                        ;	/* Interrupts */
                        ;	INTCON = 0; 		// reset and disable all interrupts by default
        CLRF  INTCON
                        ;	PEIE = 1;		// Peripherie-Interrupts freigeben
        BSF   0x0B,PEIE
                        ;	INTE = 	1;		// externen Int freigeben (INT0IE)
        BSF   0x0B,INTE
                        ;	
                        ;	GIE = 	 1;		// Enable Interrupts
        BSF   0x0B,GIE
                        ;		
                        ;
                        ;}
        RETURN
                        ;
                        ;/*------------------------------------------------------------------*/
                        ;/*    EEEE  EEEE  PPPP   RRRR    OOO   M     M                      */
                        ;/*    E     E     P   P  R   R  O   O  MM   MM                      */
                        ;/*    EEE   EEE   PPPP   RRRR   O   O  M M M M                      */
                        ;/*    E     E     P      R R    O   O  M  M  M                      */
                        ;/*    EEEE  EEEE  P      R  R    OOO   M     M                      */
                        ;/*------------------------------------------------------------------*/
                        ;
                        ;
                        ;
                        ;void write_eeprom( unsigned char adr, unsigned char data)
                        ;{
write_eeprom
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF data
                        ;	bit prev_gie = GIE;
        BCF   0x25,prev_gie
        BTFSC 0x0B,GIE
        BSF   0x25,prev_gie
                        ;	GIE = 0; 		// disable interrupts
        BCF   0x0B,GIE
                        ;	EEIF = 0; 		// clear eprom interrupt flag
        BCF   0x0D,EEIF
                        ;
                        ;	while (WR)
m019    BSF   0x03,RP0
        BSF   0x03,RP1
        BTFSS 0x18C,WR
        GOTO  m020
                        ;		; 			// wait if previous write is still busy
        GOTO  m019
                        ;
                        ;	EEADR = adr; 	// valid range is from 00h to FFh (256 bytes)
m020    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  adr,W
        BSF   0x03,RP1
        MOVWF EEADR
                        ;	//EEADR &= 0x7f; 	// prevent bugs to overwrite program memory
                        ;	EEPGD = 0;	// access data memory
        BSF   0x03,RP0
        BCF   0x18C,EEPGD
                        ;	EEDATA = data;
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  data,W
        BSF   0x03,RP1
        MOVWF EEDATA
                        ;	WREN = 1;
        BSF   0x03,RP0
        BSF   0x18C,WREN
                        ;	EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2
                        ;	EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2
                        ;	WR = 1; 		// start the actual write
        BSF   0x18C,WR
                        ;
                        ;	WREN = 0; 		// protect against unintended writes
        BCF   0x18C,WREN
                        ;	GIE = prev_gie; // restore interrupts
        BCF   0x03,RP0
        BCF   0x03,RP1
        BTFSS 0x25,prev_gie
        BCF   0x0B,GIE
        BTFSC 0x25,prev_gie
        BSF   0x0B,GIE
                        ;}
        RETURN
                        ;
                        ;unsigned char read_eeprom( unsigned char adr)
                        ;{
read_eeprom
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF adr_2
                        ;	EEADR = adr; 	// valid range is from 00h to FFh (256 bytes)
        MOVF  adr_2,W
        BSF   0x03,RP1
        MOVWF EEADR
                        ;	EEPGD = 0;	// access data memory
        BSF   0x03,RP0
        BCF   0x18C,EEPGD
                        ;
                        ;	//EEADR &= 0x7f; 	// prevent bugs to exceed program memory
                        ;	RD = 1;
        BSF   0x18C,RD
                        ;	return EEDATA;
        BCF   0x03,RP0
        MOVF  EEDATA,W
        RETURN
                        ;}
                        ;
                        ;/*------------------------------------------------------------------*/
                        ;/*    K  K  EEEE  Y   Y   SSS                                       */
                        ;/*    K K   E      Y Y   S                                          */
                        ;/*    KK    EE      Y     SSS                                       */
                        ;/*    K K   E       Y        S                                      */
                        ;/*    K  K  EEEE    Y     SSS                                       */
                        ;/*------------------------------------------------------------------*/
                        ;
                        ;
                        ;void restore_state(void)
                        ;{
restore_state
                        ;	unsigned char tester;
                        ;
                        ;	dim_grade = read_eeprom(0);
        MOVLW 0
        CALL  read_eeprom
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF dim_grade
                        ;	dim_1 = read_eeprom(1);
        MOVLW 1
        CALL  read_eeprom
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF dim_1
                        ;	dim_2 = read_eeprom(2);
        MOVLW 2
        CALL  read_eeprom
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF dim_2
                        ;
                        ;	// 2 aus 3
                        ;	if (dim_grade==dim_1)
        MOVF  dim_grade,W
        XORWF dim_1,W
        BTFSS 0x03,Zero_
        GOTO  m021
                        ;	{
                        ;	}
                        ;	else if (dim_grade==dim_2)
        GOTO  m023
m021    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  dim_grade,W
        XORWF dim_2,W
        BTFSS 0x03,Zero_
        GOTO  m022
                        ;	{
                        ;	}
                        ;	else if (dim_1 == dim_2)
        GOTO  m023
m022    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  dim_1,W
        XORWF dim_2,W
        BTFSS 0x03,Zero_
        GOTO  m023
                        ;	{
                        ;		dim_grade = dim_1;
        MOVF  dim_1,W
        MOVWF dim_grade
                        ;	}
                        ;
                        ;	// Gueltigkeit pruefen
                        ;	if (dim_grade < MIN_DIM)
m023    GOTO  m024
                        ;	{
                        ;		dim_grade = MIN_DIM;
        CLRF  dim_grade
                        ;	}
                        ;	else if (dim_grade > MAX_DIM)
        GOTO  m025
m024    MOVLW 9
        BCF   0x03,RP0
        BCF   0x03,RP1
        SUBWF dim_grade,W
        BTFSS 0x03,Carry
        GOTO  m025
                        ;	{
                        ;		dim_grade = MAX_DIM;
        MOVLW 8
        MOVWF dim_grade
                        ;	}
                        ;	
                        ;	old_dim_grade = dim_grade;	// alten dimgrad setzen, damit er nicht ins EEPROM geschrieben wird
m025    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  dim_grade,W
        MOVWF old_dim_grade
                        ;	
                        ;	actPattern = FirePattern[dim_grade]; // Aktuelles Gate-Firepattern laden
        MOVF  dim_grade,W
        CALL  _const1
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF actPattern
                        ;	
                        ;}
        RETURN
                        ;
                        ;/*------------------------------------------------------------------*/
                        ;/*    RRR    CCC    55555                                           */
                        ;/*    R  R  C   C   5                                               */
                        ;/*    RRR   C       5555                                            */
                        ;/*    R R   C   C       5                                           */
                        ;/*    R  R   CCC    5555                                            */
                        ;/*------------------------------------------------------------------*/
                        ;
                        ;// 8MHz crystal, 2MHz cycle time, TMR0 prescale=64: timer units of 32 usec.
                        ;// TRM0 expires at 8 msec.
                        ;
                        ;extern uns8 tmr0wait( void)
                        ;{
tmr0wait
                        ;	tmr0cpy = 0xff; // potential longest waiting time, reduced by irled
        MOVLW 255
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF tmr0cpy
                        ;	while (!T0IF) // wait for TMR0 wrap-around or IRled
m026    BTFSC 0x0B,T0IF
        GOTO  m027
                        ;		;
        GOTO  m026
                        ;
                        ;	T0IF = 0;
m027    BCF   0x0B,T0IF
                        ;	return tmr0cpy;
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  tmr0cpy,W
        RETURN
                        ;}
                        ;
                        ;void ir_bogus( void)
                        ;{
ir_bogus
                        ;	// just eat irled input, as long as we have fast pulses
                        ;	uns8 t;
                        ;
                        ;	t = 0;
        BCF   0x03,RP0
        BCF   0x03,RP1
        CLRF  t
                        ;	while (t < 200)
m028    MOVLW 200
        BCF   0x03,RP0
        BCF   0x03,RP1
        SUBWF t,W
        BTFSC 0x03,Carry
        GOTO  m029
                        ;	   t = tmr0wait();
        CALL  tmr0wait
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF t
        GOTO  m028
                        ;
                        ;	ircode = 0xffffL; // bogus code;
m029    MOVLW 255
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF ircode
        MOVLW 255
        MOVWF ircode+1
                        ;}
        RETURN
                        ;
                        ;void ir_philips_rc5(void) // now assuming no 'extended' RC5, so S2==1
                        ;{
ir_philips_rc5
                        ;	// 1 is sequence dark,light:  2x 900us == 2x28
                        ;	// 0 is sequence light,dark:  2x 900us == 2x28
                        ;	// frame is: one,one,toggle,11xdata
                        ;	unsigned char t;
                        ;	unsigned char i;
                        ;
                        ;	t = 0;
        BCF   0x03,RP0
        BCF   0x03,RP1
        CLRF  t_2
                        ;	i = 0;
        CLRF  i
                        ;	ircode = 0L;
        CLRF  ircode
        CLRF  ircode+1
                        ;	// starting now in the 2nd (light) half S2
                        ;	while (t < 80)
m030    MOVLW 80
        BCF   0x03,RP0
        BCF   0x03,RP1
        SUBWF t_2,W
        BTFSC 0x03,Carry
        GOTO  m033
                        ;	{
                        ;	   // last half of current bit still to be measured, its timer is running
                        ;	   ircode <<=1; // insert current value
        BCF   0x03,Carry
        RLF   ircode,1
        RLF   ircode+1,1
                        ;	   if (irled) // irled input is active low
        MOVF  irled,1
        BTFSC 0x03,Zero_
        GOTO  m031
                        ;		   ircode.0 = 1;
        BSF   ircode,0
                        ;	   i++;
m031    BCF   0x03,RP0
        BCF   0x03,RP1
        INCF  i,1
                        ;
                        ;	   t = tmr0wait();
        CALL  tmr0wait
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF t_2
                        ;
                        ;	   if (t < 38) // new codebit is same as current, edge at bit boundary
        MOVLW 38
        SUBWF t_2,W
        BTFSC 0x03,Carry
        GOTO  m032
                        ;	   {
                        ;	   	  t=tmr0wait(); // skip first half of new bit
        CALL  tmr0wait
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF t_2
                        ;	   }
                        ;	}
m032    GOTO  m030
                        ;
                        ;	ircode.high8 &= 0x07; // clear start bits S2 and T
m033    MOVLW 7
        BCF   0x03,RP0
        BCF   0x03,RP1
        ANDWF ircode+1,1
                        ;
                        ;	if (i < 13)
        MOVLW 13
        SUBWF i,W
        BTFSC 0x03,Carry
        GOTO  m034
                        ;	{
                        ;		ircode = 0xffffL; // bogus
        MOVLW 255
        MOVWF ircode
        MOVLW 255
        MOVWF ircode+1
                        ;	}
                        ;}
m034    RETURN
                        ;
                        ;
                        ;void get_ir( void)
                        ;{
get_ir
                        ;	unsigned char ton;
                        ;	unsigned char toff;
                        ;
                        ;    ton = tmr0wait(); // measure first light
        CALL  tmr0wait
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF ton
                        ;	toff = tmr0wait(); // following first dark
        CALL  tmr0wait
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF toff
                        ;
                        ;    if (ton  > 20 && ton  < 36 &&  // nominal 900/32 = 28
        MOVLW 21
        SUBWF ton,W
        BTFSS 0x03,Carry
        GOTO  m035
        MOVLW 36
        SUBWF ton,W
        BTFSC 0x03,Carry
        GOTO  m035
                        ;        toff > 20 && toff < 36)  // nominal 900/32 = 28
        MOVLW 21
        SUBWF toff,W
        BTFSS 0x03,Carry
        GOTO  m035
        MOVLW 36
        SUBWF toff,W
        BTFSC 0x03,Carry
        GOTO  m035
                        ;    {
                        ;		ir_philips_rc5();
        CALL  ir_philips_rc5
                        ;	}
                        ;	else
        GOTO  m036
                        ;	{
                        ;		ir_bogus();
m035    GOTO  ir_bogus
                        ;	}
                        ;}
m036    RETURN
                        ;
                        ;void do_remote(void)
                        ;{
do_remote
                        ;#pragma updateBank 0
                        ;
                        ;	unsigned char h;
                        ;
                        ;	// systemadresse testen
                        ;	h = ircode.high8 & 0b.0000.0111;
        MOVLW 7
        ANDWF ircode+1,W
        MOVWF h
                        ;	if (h != 4)
        MOVF  h,W
        XORLW 4
        BTFSC 0x03,Zero_
        GOTO  m037
                        ;	{
                        ;		return;
        RETURN
                        ;	}
                        ;
                        ;	h = ircode.low8 & 0b.1100.0000;
m037    MOVLW 192
        ANDWF ircode,W
        MOVWF h
                        ;	if (h != 0)
        MOVF  h,1
        BTFSC 0x03,Zero_
        GOTO  m038
                        ;	{
                        ;		return;
        RETURN
                        ;	}
                        ;
                        ;	// okay, Kommando gilt uns: Kommando extrahieren
                        ;	h= ircode.low8 & 0b.0011.1111;
m038    MOVLW 63
        ANDWF ircode,W
        MOVWF h
                        ;
                        ;	// Quellenwahltasten = 1..8
                        ;	if (h<=MAX_DIM)
        MOVLW 9
        SUBWF h,W
        BTFSC 0x03,Carry
        GOTO  m039
                        ;	{
                        ;		dim_grade = h;
        MOVF  h,W
        MOVWF dim_grade
                        ;	}
                        ;	
                        ;
                        ;	if (h == 16) // Volume +
m039    MOVF  h,W
        XORLW 16
        BTFSS 0x03,Zero_
        GOTO  m041
                        ;	{
                        ;		if (dim_grade < MAX_DIM)
        MOVLW 8
        SUBWF dim_grade,W
        BTFSC 0x03,Carry
        GOTO  m040
                        ;		{
                        ;			dim_grade++;
        INCF  dim_grade,1
                        ;		}
                        ;	}
                        ;	else if (h == 17) // Volume -
m040    GOTO  m044
m041    MOVF  h,W
        XORLW 17
        BTFSS 0x03,Zero_
        GOTO  m043
                        ;	{
                        ;		if (dim_grade >= 1)
        MOVF  dim_grade,1
        BTFSC 0x03,Zero_
        GOTO  m042
                        ;		{
                        ;			dim_grade--;
        DECF  dim_grade,1
                        ;		}
                        ;		
                        ;	}
                        ;	else if (h == 12) // Standby-> Dimmgrad 0
m042    GOTO  m044
m043    MOVF  h,W
        XORLW 12
        BTFSS 0x03,Zero_
        GOTO  m044
                        ;	{
                        ;		dim_grade=0;		
        CLRF  dim_grade
                        ;	}
                        ;
                        ;	actPattern = FirePattern[dim_grade]; // Aktuelles Gate-Firepattern laden
m044    MOVF  dim_grade,W
        CALL  _const1
        MOVWF actPattern
                        ;#pragma updateBank 1
                        ;}
        RETURN
                        ;
                        ;// einen Piepton ausgeben
                        ;void beep (void)
                        ;{
beep
                        ;#pragma updateBank 0
                        ;
                        ;	unsigned char waiter;
                        ;	unsigned char counter;	
                        ;	
                        ;	for (counter = 0; counter < 200; counter++)
        CLRF  counter
m045    MOVLW 200
        SUBWF counter,W
        BTFSC 0x03,Carry
        GOTO  m048
                        ;	{
                        ;		for (waiter=0; waiter < 24 ; waiter++)
        CLRF  waiter
m046    MOVLW 24
        SUBWF waiter,W
        BTFSC 0x03,Carry
        GOTO  m047
                        ;		{
                        ;			NOP; // 80 = 1.25kHz 24=4kHz
        NOP  
                        ;		}
        INCF  waiter,1
        GOTO  m046
                        ;		BUZZER ^= 1;
m047    MOVLW 1
        XORWF PORTA,1
                        ;	}
        INCF  counter,1
        GOTO  m045
                        ;	
                        ;	BUZZER = 0;
m048    BCF   PORTA,0
                        ;#pragma updateBank 1
                        ;}
        RETURN
                        ;
                        ;// --- Neu starten der Gate-Ansteuerung nach Reset oder IR-Empfang
                        ;void neustart(void)
                        ;{
neustart
                        ;	// Timer 1 auf die nchste fallende Flanke stellen
                        ;	CCP1CON = 	0; // Capture stoppen und reset
        BCF   0x03,RP0
        BCF   0x03,RP1
        CLRF  CCP1CON
                        ;	TMR1ON = 0; // Timer stoppen
        BCF   0x10,TMR1ON
                        ;	TMR1H = 0;
        CLRF  TMR1H
                        ;	TMR1L = 0;
        CLRF  TMR1L
                        ;	CCP1CON = 	0b0000.0100; // Capture every falling edge
        MOVLW 4
        MOVWF CCP1CON
                        ;	
                        ;	// Statemachine auf Anfang
                        ;	Puls = 		0;
        CLRF  Puls
                        ;	
                        ;	// Sonstige Variablen
                        ;	cycles = 	0;
        CLRF  cycles
                        ;	PulseOn = 	0;
        BCF   0x2C,PulseOn
                        ;	Stable =        0;
        BCF   0x2C,Stable
                        ;	PatternPos =	0;
        CLRF  PatternPos
                        ;	PatternMask =   1;
        MOVLW 1
        MOVWF PatternMask
                        ;	actPattern = FirePattern[dim_grade]; // Aktuelles Gate-Firepattern laden
        MOVF  dim_grade,W
        CALL  _const1
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF actPattern
                        ;	
                        ;		
                        ;	//Timer 1 starten 
                        ;	TMR1ON = 1;
        BSF   0x10,TMR1ON
                        ;	
                        ;	// Capture-Interrupt aktivieren
                        ;	CCP1IE = 1;	
        BSF   0x03,RP0
        BSF   0x8C,CCP1IE
                        ;}
        RETURN
                        ;
                        ;void uhr_betreiben(void)
                        ;{
uhr_betreiben
                        ;#pragma updateBank 0
                        ;	
                        ;	if (cycles > 49) // mehr als 50 Cycles-> eine sekunde vergangen
        MOVLW 50
        SUBWF cycles,W
        BTFSS 0x03,Carry
        GOTO  m049
                        ;	{
                        ;		cycles-=50; // restcycles nicht wegwerfen
        MOVLW 50
        SUBWF cycles,1
                        ;		seconds++;
        INCF  seconds,1
                        ;		
                        ;		if (seconds > 59) // sechzig sec vergangen -> eine Minute ist um
        MOVLW 60
        SUBWF seconds,W
        BTFSS 0x03,Carry
        GOTO  m049
                        ;		{
                        ;			seconds = 0;
        CLRF  seconds
                        ;			minutes++;
        INCF  minutes,1
                        ;			
                        ;			if (minutes > 59)
        MOVLW 60
        SUBWF minutes,W
        BTFSS 0x03,Carry
        GOTO  m049
                        ;			{
                        ;				minutes=0;
        CLRF  minutes
                        ;				hours++;
        INCF  hours,1
                        ;			}
                        ;		
                        ;		}
                        ;	}
                        ;#pragma updateBank 1	
                        ;}
m049    RETURN
                        ;
                        ;
                        ;
                        ;/*------------------------------------------------------------------*/
                        ;/*     M     M    A    II  N   N                                    */
                        ;/*     MM   MM   A A   II  NN  N                                    */
                        ;/*     M M M M  A   A  II  N N N                                    */
                        ;/*     M  M  M  AAAAA  II  N  NN                                    */
                        ;/*     M     M  A   A  II  N   N                                    */
                        ;/*------------------------------------------------------------------*/
                        ;
                        ;void main (void)
                        ;{
main
                        ;	unsigned char tmp;
                        ;
                        ;	init();
        CALL  init
                        ;	
                        ;	clrwdt();
        CLRWDT
                        ;	
                        ;	beep();
        CALL  beep
                        ;
                        ;	restore_state();
        CALL  restore_state
                        ;	
                        ;	neustart();
        CALL  neustart
                        ;
                        ;	while (1)
                        ;	{
                        ;		
                        ;		clrwdt();
m050    CLRWDT
                        ;		
                        ;		uhr_betreiben();
        CALL  uhr_betreiben
                        ;		
                        ;		// == Betriebsart-LED
                        ;		// Dimgrad 0:   alle 10s blink
                        ;		// Dimgrad 1-8: sekundentakt-blink
                        ;		//
                        ;		if (dim_grade)
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  dim_grade,1
        BTFSC 0x03,Zero_
        GOTO  m051
                        ;		{				
                        ;			tmp = seconds % 2;
        MOVLW 1
        ANDWF seconds,W
        MOVWF tmp
                        ;		}
                        ;		else
        GOTO  m055
                        ;		{
                        ;			tmp = seconds % 10;
m051    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  seconds,W
        MOVWF C2tmp
        CLRF  tmp
        MOVLW 8
        MOVWF C1cnt
m052    BCF   0x03,RP0
        BCF   0x03,RP1
        RLF   C2tmp,1
        RLF   tmp,1
        MOVLW 10
        SUBWF tmp,W
        BTFSS 0x03,Carry
        GOTO  m054
m053    MOVLW 10
        BCF   0x03,RP0
        BCF   0x03,RP1
        SUBWF tmp,1
m054    BCF   0x03,RP0
        BCF   0x03,RP1
        DECFSZ C1cnt,1
        GOTO  m052
                        ;		}
                        ;						
                        ;		if (tmp)
m055    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  tmp,1
        BTFSC 0x03,Zero_
        GOTO  m056
                        ;		{
                        ;			LED_OFF = 1;
        BSF   PORTA,1
                        ;		}
                        ;		else
        GOTO  m057
                        ;		{
                        ;			LED_OFF = 0;
m056    BCF   0x03,RP0
        BCF   0x03,RP1
        BCF   PORTA,1
                        ;		}
                        ;				
                        ;		// == Timer-Jobs behandeln
                        ;		
                        ;		if (seconds > 3) // Starttimer zur Stabilisierung
m057    MOVLW 4
        BCF   0x03,RP0
        BCF   0x03,RP1
        SUBWF seconds,W
        BTFSS 0x03,Carry
        GOTO  m058
                        ;		{
                        ;			Stable = 1;
        BSF   0x2C,Stable
                        ;		}
                        ;		
                        ;		if (hours > 7) // Notbremse ziehen: nach 8 Stunden Dimmgrad auf 0
m058    MOVLW 8
        BCF   0x03,RP0
        BCF   0x03,RP1
        SUBWF hours,W
        BTFSS 0x03,Carry
        GOTO  m059
                        ;		{
                        ;			dim_grade = 0;
        CLRF  dim_grade
                        ;			seconds = 0; // Zeitrechnung neu starten
        CLRF  seconds
                        ;			minutes = 0;
        CLRF  minutes
                        ;			hours = 0;	
        CLRF  hours
                        ;		}
                        ;		
                        ;		
                        ;		tmp = tmr0wait(); // wrap-around or interrupt, wrap-around takes 8ms
m059    CALL  tmr0wait
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF tmp
                        ;	
                        ;	    	if (irled) //came out of wait by interrupt: light on, start of new code
        MOVF  irled,1
        BTFSC 0x03,Zero_
        GOTO  m060
                        ;		{
                        ;			get_ir();
        CALL  get_ir
                        ;			do_remote();
        CALL  do_remote
                        ;		}
                        ;		
                        ;		// wenn sich der dimmgrad gendert hat, ins EEPROM schreiben
                        ;		if (old_dim_grade != dim_grade)
m060    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  old_dim_grade,W
        XORWF dim_grade,W
        BTFSC 0x03,Zero_
        GOTO  m061
                        ;		{
                        ;			beep();
        CALL  beep
                        ;			
                        ;			save_counter = SAVETIME;
        MOVLW 113
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF save_counter
        MOVLW 2
        MOVWF save_counter+1
                        ;			
                        ;			old_dim_grade = dim_grade;			
        MOVF  dim_grade,W
        MOVWF old_dim_grade
                        ;		}
                        ;		
                        ;		// wartezeit vor dem speichern abgelaufen?
                        ;		if (save_counter == 1)
m061    BCF   0x03,RP0
        BCF   0x03,RP1
        DECF  save_counter,W
        IORWF save_counter+1,W
        BTFSS 0x03,Zero_
        GOTO  m062
                        ;		{	
                        ;			write_eeprom(0,dim_grade);
        CLRF  adr
        MOVF  dim_grade,W
        CALL  write_eeprom
                        ;			write_eeprom(1,dim_grade);
        MOVLW 1
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF adr
        MOVF  dim_grade,W
        CALL  write_eeprom
                        ;			write_eeprom(2,dim_grade);
        MOVLW 2
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF adr
        MOVF  dim_grade,W
        CALL  write_eeprom
                        ;			
                        ;			save_counter = 0; // speichern erledigt
        BCF   0x03,RP0
        BCF   0x03,RP1
        CLRF  save_counter
        CLRF  save_counter+1
                        ;		}
                        ;		else if (save_counter > 1)
        GOTO  m064
m062    BCF   0x03,RP0
        BCF   0x03,RP1
        MOVF  save_counter+1,W
        BTFSS 0x03,Zero_
        GOTO  m063
        MOVLW 2
        SUBWF save_counter,W
        BTFSS 0x03,Carry
        GOTO  m064
                        ;		{
                        ;			save_counter--;
m063    BCF   0x03,RP0
        BCF   0x03,RP1
        DECF  save_counter,1
        INCF  save_counter,W
        BTFSC 0x03,Zero_
        DECF  save_counter+1,1
                        ;		}
                        ;		
                        ;
                        ;	} /* while (1) */
m064    GOTO  m050

        END


; *** KEY INFO ***

; 0x0004 P0  149 word(s)  7 % : int_server
; 0x00AF P0   36 word(s)  1 % : init
; 0x00D3 P0   40 word(s)  1 % : write_eeprom
; 0x00FB P0   12 word(s)  0 % : read_eeprom
; 0x0107 P0   56 word(s)  2 % : restore_state
; 0x0099 P0   22 word(s)  1 % : _const1
; 0x013F P0   12 word(s)  0 % : tmr0wait
; 0x014B P0   21 word(s)  1 % : ir_bogus
; 0x0160 P0   48 word(s)  2 % : ir_philips_rc5
; 0x0190 P0   28 word(s)  1 % : get_ir
; 0x01AC P0   52 word(s)  2 % : do_remote
; 0x01E0 P0   19 word(s)  0 % : beep
; 0x01F3 P0   24 word(s)  1 % : neustart
; 0x020B P0   20 word(s)  0 % : uhr_betreiben
; 0x021F P0  132 word(s)  6 % : main

; RAM usage: 27 bytes (8 local), 341 bytes free
; Maximum call level: 3 (+1 for interrupt)
;  Codepage 0 has  672 word(s) :  32 %
;  Codepage 1 has    0 word(s) :   0 %
; Total of 672 code words (16 %)
